HDU 4849 (最短路 水~)

 
除了校赛,还有什么途径可以申请加入ACM校队? 

Wow! Such City!

Time Limit: 15000/8000 MS (Java/Others)    Memory Limit: 102400/102400 K (Java/Others)
Total Submission(s): 1453    Accepted Submission(s): 500


Problem Description
Doge, tired of being a popular image on internet, is considering moving to another city for a new way of life.
In his country there are N (2 ≤N≤ 1000) cities labeled 0 . . . N - 1. He is currently in city 0. Meanwhile, for each pair of cities, there exists a road connecting them, costing C i, j (a positive integer) for traveling from city i to city j. Please note that C i, j may not equal to C j, i for any given i ≠ j.
Doge is carefully examining the cities: in fact he will divide cities (his current city 0 is  NOT included) into M (2 ≤ M ≤ 10 6) categories as follow: If the minimal cost from his current city (labeled 0) to the city i is Di, city i belongs to category numbered  Di mod M.Doge wants to know the “minimal” category (a category with minimal number) which contains at least one city.
For example, for a country with 4 cities (labeled 0 . . . 3, note that city 0 is not considered), Doge wants to divide them into 3 categories. Suppose category 0 contains no city, category 1 contains city 2 and 3, while category 2 contains city 1, Doge consider category 1 as the minimal one.
Could you please help Doge solve this problem?

Note:

C i, j is generated in the following way:
Given integers X 0, X 1, Y 0, Y 1, (1 ≤ X 0, X 1, Y 0, Y 1≤ 1234567), for k ≥ 2 we have
Xk  = (12345 + X k-1 * 23456 + X k-2 * 34567 + X k-1 * X k-2 * 45678)  mod  5837501
Yk  = (56789 + Y k-1 * 67890 + Y k-2 * 78901 + Y k-1 * Y k-2 * 89012)  mod  9860381
The for k ≥ 0 we have

Z k = (X k * 90123 + Y k ) mod 8475871 + 1

Finally for 0 ≤ i, j ≤ N - 1 we have

C i, j = Z i*n+j for i ≠ j
C i, j = 0   for i = j
 

Input
There are several test cases. Please process till EOF.
For each test case, there is only one line containing 6 integers N,M,X 0,X 1,Y 0,Y 1.See the description for more details.
 

Output
For each test case, output a single line containing a single integer: the number of minimal category.
 

Sample Input
       
       
       
       
3 10 1 2 3 4 4 20 2 3 4 5
 

Sample Output
       
       
       
       
1 10 For the first test case, we have 0 1 2 3 4 5 6 7 8 X 1 2 185180 788997 1483212 4659423 4123738 2178800 219267 Y 3 4 1633196 7845564 2071599 4562697 3523912 317737 1167849 Z 90127 180251 1620338 2064506 625135 5664774 5647950 8282552 4912390 the cost matrix C is 0 180251 1620338 2064506 0 5664774 5647950 8282552 0
Hint
So the minimal cost from city 0 to city 1 is 180251, while the distance to city 2 is 1620338. Given M = 10, city 1 and city 2 belong to category 1 and 8 respectively. Since only category 1 and 8 contain at least one city, the minimal one of them, category 1, is the desired answer to Doge’s question.
 

题意:按照题目求出xyz三个数组,然后算出距离矩阵,然后从0跑最短路,所有的对短路模m后求出所有的值中

最小的.

裸题.

#include <bits/stdc++.h>
using namespace std;
#define maxn 1111

long long n, m;
long long x[maxn*maxn], y[maxn*maxn], z[maxn*maxn];
long long mp[maxn][maxn];
long long d[maxn];
const long long INF = 1e18;
bool vis[maxn];

void dij () {
    for (int i = 0; i < n; i++)
        d[i] = INF;
    memset (vis, 0, sizeof vis);
    d[0] = 0;
    for (int i = 0; i < n; i++) {
        long long Min = INF, pos;
        for (int j = 0; j < n; j++) if (!vis[j] && d[j] < Min) {
            Min = d[j];
            pos = j;
        }
        vis[pos] = 1;
        for (int j = 0; j < n; j++) if (!vis[j]) {
            d[j] = min (d[j], d[pos]+mp[pos][j]);
        }
    }
    for (int i = 0; i < n; i++) d[i] %= m;
    long long ans = d[1];
    //for (int i = 0; i < n; i++) cout << d[i] << endl;
    for (int i = 1; i < n; i++) {
        ans = min (ans, d[i]);
    }
    cout << ans << endl;
}

int main () {
    //freopen ("in.txt", "r", stdin);
    while (cin >> n >> m >> x[0] >> x[1] >> y[0] >> y[1]) {
        for (int i = 0; i < n*n; i++) {
            if (i >= 2)
                x[i] = (12345 + x[i-1] * 23456 + x[i-2] * 34567 + x[i-1] * x[i-2] * 45678)  %  5837501;
            if (i >= 2)
                y[i] = (56789 + y[i-1] * 67890 + y[i-2] * 78901 + y[i-1] * y[i-2] * 89012)  %  9860381;
            z[i] = (x[i]*90123 + y[i]) % 8475871 + 1;
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i == j)
                    mp[i][j] = 0;
                else
                    mp[i][j] = z[i*n+j];
            }
        }
        dij ();
    }
    return 0;
}


你可能感兴趣的:(HDU 4849 (最短路 水~))